/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This is GNU GO, a Go program. Contact gnugo@gnu.org, or see       *
 * http://www.gnu.org/software/gnugo/ for more information.          *
 *                                                                   *
 * Copyright 1999, 2000, 2001, 2002 and 2003                         *
 * by the Free Software Foundation.                                  *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 2             *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 59 Temple Place - Suite 330,           *
 * Boston, MA 02111, USA.                                            *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h> /* for NULL */
#include "liberty.h"
#include "patterns.h"

static struct patval fusekipat0[] = {
  {684,1},	{906,2},	{905,4},	{942,4},
  {868,4},	{831,0},	{757,0},	{609,0},
  {573,0},	{610,0},	{647,0},	{572,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{794,0},	{943,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0}
};

static struct patval fusekipat1[] = {
  {684,1},	{831,4},	{868,4},	{794,4},
  {572,0},	{757,0},	{573,0},	{610,0},
  {647,0},	{609,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval fusekipat2[] = {
  {684,1},	{868,4},	{907,4},	{794,4},
  {831,4},	{905,4},	{572,0},	{757,0},
  {610,0},	{647,0},	{609,0},	{721,0},
  {758,0},	{795,0},	{573,0},	{869,0},
  {906,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{832,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0}
};

static struct patval fusekipat3[] = {
  {684,1},	{907,3},	{906,3},	{609,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{573,0},	{610,0},
  {647,0},	{683,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{646,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{572,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat4[] = {
  {684,1},	{572,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{573,0},	{610,0},	{647,0},
  {609,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval fusekipat5[] = {
  {684,1},	{905,4},	{906,4},	{943,4},
  {942,4},	{907,4},	{944,4},	{757,0},
  {868,0},	{609,0},	{720,0},	{573,0},
  {610,0},	{647,0},	{794,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {646,0},	{683,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{831,0},
  {572,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0}
};

static struct patval fusekipat6[] = {
  {684,1},	{907,3},	{906,3},	{609,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{573,0},	{610,0},
  {647,0},	{683,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{646,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{572,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat7[] = {
  {684,1},	{572,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{573,0},	{610,0},	{647,0},
  {609,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval fusekipat8[] = {
  {684,1},	{945,4},	{906,4},	{943,4},
  {946,4},	{909,4},	{908,4},	{907,4},
  {944,4},	{905,4},	{942,4},	{757,0},
  {720,0},	{647,0},	{794,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {646,0},	{683,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{831,0},
  {868,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{572,0},	{609,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{573,0},	{610,0}
};

static struct patval fusekipat9[] = {
  {684,1},	{907,3},	{906,3},	{609,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{573,0},	{610,0},
  {647,0},	{683,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{646,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{572,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat10[] = {
  {684,1},	{571,0},	{645,0},	{682,0},
  {572,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{573,0},	{610,0},	{647,0},
  {608,0},	{721,0},	{758,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0}
};

static struct patval fusekipat11[] = {
  {684,1},	{572,0},	{646,0},	{573,0},
  {610,0},	{647,0},	{609,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval fusekipat12[] = {
  {684,1},	{645,0},	{608,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{610,0},	{647,0},
  {682,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval fusekipat13[] = {
  {684,1},	{907,4},	{906,4},	{719,0},
  {645,0},	{793,0},	{608,0},	{867,0},
  {904,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{610,0},	{647,0},
  {830,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{682,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{756,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat14[] = {
  {684,1},	{645,0},	{608,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{610,0},	{647,0},
  {682,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval fusekipat15[] = {
  {684,1},	{869,4},	{906,4},	{870,4},
  {907,4},	{793,0},	{608,0},	{867,0},
  {904,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{610,0},	{647,0},
  {830,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{645,0},	{682,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{719,0},	{756,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat16[] = {
  {684,1},	{570,0},	{534,0},	{533,0},
  {608,0},	{645,0},	{535,0},	{572,0},
  {609,0},	{646,0},	{536,0},	{573,0},
  {610,0},	{647,0},	{571,0},	{537,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0}
};

static struct patval fusekipat17[] = {
  {684,1},	{569,0},	{606,0},	{643,0},
  {532,0},	{717,0},	{533,0},	{570,0},
  {607,0},	{644,0},	{681,0},	{718,0},
  {534,0},	{571,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{535,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{536,0},
  {573,0},	{610,0},	{647,0},	{680,0},
  {537,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0}
};

static struct patval fusekipat18[] = {
  {684,1},	{529,0},	{603,0},	{640,0},
  {677,0},	{714,0},	{530,0},	{567,0},
  {604,0},	{641,0},	{678,0},	{715,0},
  {531,0},	{568,0},	{605,0},	{642,0},
  {679,0},	{716,0},	{532,0},	{569,0},
  {606,0},	{643,0},	{680,0},	{717,0},
  {533,0},	{570,0},	{607,0},	{644,0},
  {681,0},	{718,0},	{534,0},	{571,0},
  {608,0},	{645,0},	{682,0},	{719,0},
  {535,0},	{572,0},	{609,0},	{646,0},
  {683,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{566,0},	{537,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{538,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0}
};

static struct patval fusekipat19[] = {
  {684,1},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{573,0},	{610,0},
  {647,0},	{572,0},	{721,0},	{758,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0}
};

static struct patval fusekipat20[] = {
  {684,1},	{608,0},	{572,0},	{609,0},
  {646,0},	{573,0},	{610,0},	{647,0},
  {571,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval fusekipat21[] = {
  {684,1},	{644,0},	{681,0},	{718,0},
  {607,0},	{792,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{793,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{610,0},	{647,0},
  {755,0},	{721,0},	{758,0},	{795,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0}
};

static struct patval fusekipat22[] = {
  {684,1},	{640,0},	{603,0},	{714,0},
  {751,0},	{788,0},	{825,0},	{862,0},
  {604,0},	{641,0},	{678,0},	{677,0},
  {752,0},	{789,0},	{826,0},	{863,0},
  {605,0},	{642,0},	{679,0},	{716,0},
  {753,0},	{790,0},	{827,0},	{864,0},
  {606,0},	{643,0},	{680,0},	{717,0},
  {754,0},	{791,0},	{828,0},	{865,0},
  {607,0},	{644,0},	{681,0},	{718,0},
  {755,0},	{792,0},	{829,0},	{866,0},
  {608,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{867,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {610,0},	{647,0},	{715,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0}
};

static struct patval fusekipat23[] = {
  {684,1},	{906,4},	{643,4},	{680,4},
  {907,4},	{754,0},	{791,0},	{717,0},
  {865,0},	{902,0},	{570,0},	{607,0},
  {569,0},	{606,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{866,0},	{903,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {573,0},	{610,0},	{647,0},	{828,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{681,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{644,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat24[] = {
  {684,1},	{906,4},	{643,4},	{680,4},
  {907,4},	{754,0},	{791,0},	{717,0},
  {865,0},	{902,0},	{570,0},	{607,0},
  {569,0},	{606,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{866,0},	{903,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {573,0},	{610,0},	{647,0},	{828,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{681,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{644,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat25[] = {
  {684,2},	{571,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{535,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {536,0},	{573,0},	{610,0},	{647,0},
  {534,0},	{721,0},	{537,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval fusekipat26[] = {
  {684,2},	{869,4},	{832,4},	{870,4},
  {907,4},	{906,4},	{833,4},	{867,0},
  {793,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{610,0},	{647,0},
  {830,0},	{721,0},	{758,0},	{795,0},
  {608,0},	{645,0},	{904,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{682,0},	{719,0},	{756,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat27[] = {
  {684,2},	{645,0},	{608,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{610,0},	{647,0},
  {682,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval fusekipat28[] = {
  {684,2},	{645,0},	{608,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{867,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {610,0},	{647,0},	{682,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval fusekipat29[] = {
  {684,2},	{533,0},	{607,0},	{644,0},
  {681,0},	{718,0},	{755,0},	{534,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{535,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{570,0},	{721,0},	{758,0},
  {537,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{538,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0}
};

static struct patval fusekipat30[] = {
  {684,2},	{686,2},	{647,0},	{573,0},
  {721,0},	{758,0},	{610,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {575,0},	{612,0},	{649,0},	{574,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{578,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0}
};

static struct patval fusekipat31[] = {
  {723,2},	{684,2},	{647,0},	{610,0},
  {758,0},	{795,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{721,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0}
};

static struct patval fusekipat32[] = {
  {724,2},	{684,2},	{647,0},	{610,0},
  {758,0},	{795,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{721,0},	{761,0},	{798,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {616,0},	{653,0},	{690,0},	{727,0},
  {764,0},	{801,0}
};

static struct patval fusekipat33[] = {
  {798,1},	{723,2},	{684,2},	{647,0},
  {758,0},	{795,0},	{611,0},	{610,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {612,0},	{649,0},	{686,0},	{721,0},
  {760,0},	{797,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{648,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0}
};

static struct patval fusekipat34[] = {
  {684,2},	{607,0},	{644,0},	{570,0},
  {718,0},	{755,0},	{792,0},	{571,0},
  {608,0},	{645,0},	{682,0},	{719,0},
  {756,0},	{793,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{573,0},	{610,0},	{647,0},
  {681,0},	{721,0},	{758,0},	{795,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0}
};

static struct patval fusekipat35[] = {
  {684,2},	{604,0},	{641,0},	{678,0},
  {567,0},	{752,0},	{789,0},	{568,0},
  {605,0},	{642,0},	{679,0},	{716,0},
  {753,0},	{790,0},	{569,0},	{606,0},
  {643,0},	{680,0},	{717,0},	{754,0},
  {791,0},	{570,0},	{607,0},	{644,0},
  {681,0},	{718,0},	{755,0},	{792,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{573,0},	{610,0},
  {647,0},	{715,0},	{721,0},	{758,0},
  {795,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0}
};

static struct patval fusekipat36[] = {
  {684,2},	{906,2},	{645,3},	{682,3},
  {719,0},	{756,0},	{793,0},	{571,0},
  {608,0},	{904,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {573,0},	{610,0},	{647,0},	{830,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{867,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat37[] = {
  {686,2},	{684,2},	{647,0},	{610,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{943,0},	{980,0},
  {1017,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{575,0},	{612,0},
  {649,0},	{573,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{982,0},	{1019,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0},
  {1021,0}
};

static struct patval fusekipat38[] = {
  {723,2},	{684,2},	{647,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {906,0},	{943,0},	{980,0},	{1017,0},
  {1054,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{981,0},
  {1018,0},	{1055,0},	{612,0},	{649,0},
  {686,0},	{610,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0},	{983,0},	{1020,0},	{1057,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{947,0},	{984,0},	{1021,0},
  {1058,0}
};

static struct patval fusekipat39[] = {
  {686,2},	{684,2},	{721,0},	{647,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {649,0},	{758,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{873,0},	{910,0}
};

static struct patval fusekipat40[] = {
  {684,2},	{723,2},	{758,0},	{721,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {686,0},	{795,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{873,0},	{910,0},
  {947,0}
};

static struct patval fusekipat41[] = {
  {982,1},	{723,2},	{684,2},	{795,0},
  {721,0},	{869,0},	{758,0},	{943,0},
  {980,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{686,0},	{832,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0},	{906,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0},	{983,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{873,0},	{910,0},	{947,0},
  {984,0}
};

static struct patval fusekipat42[] = {
  {758,2},	{684,2},	{646,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{610,0},	{647,0},	{683,0},
  {721,0},	{609,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{943,0},	{980,0},
  {1017,0},	{1054,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{982,0},	{1019,0},	{1056,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0}
};

static struct patval fusekipat43[] = {
  {684,2},	{759,2},	{609,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{610,0},	{647,0},	{683,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{943,0},	{980,0},
  {1017,0},	{1054,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{646,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {945,0},	{982,0},	{1019,0},	{1056,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0}
};

static struct patval fusekipat44[] = {
  {945,2},	{684,2},	{686,2},	{758,0},
  {721,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{649,0},	{795,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{647,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{873,0},	{910,0},
  {947,0}
};

static struct patval fusekipat45[] = {
  {1128,2},	{684,2},	{571,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{608,0},
  {1015,0},	{1052,0},	{1089,0},	{1126,0},
  {1163,0},	{1200,0},	{1237,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{1127,0},	{1164,0},
  {1201,0},	{1238,0},	{573,0},	{610,0},
  {647,0},	{978,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{980,0},	{1017,0},	{1054,0},
  {1091,0},	{645,0},	{1165,0},	{1202,0},
  {1239,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{1092,0},
  {1129,0},	{1166,0},	{1203,0},	{1240,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {1019,0},	{1056,0},	{1093,0},	{1130,0},
  {1167,0},	{1204,0},	{1241,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0},	{1131,0},	{1168,0},
  {1205,0},	{1242,0}
};

static struct patval fusekipat46[] = {
  {684,2},	{607,0},	{570,0},	{681,0},
  {718,0},	{755,0},	{792,0},	{829,0},
  {866,0},	{903,0},	{940,0},	{977,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{978,0},
  {572,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{942,0},	{979,0},
  {573,0},	{610,0},	{647,0},	{644,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{943,0},	{980,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{981,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0},	{983,0}
};

static struct patval fusekipat47[] = {
  {943,1},	{869,2},	{684,2},	{866,0},
  {830,0},	{719,0},	{904,0},	{941,0},
  {683,0},	{720,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {756,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{793,0},	{906,0},	{867,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0}
};

static struct patval fusekipat48[] = {
  {684,2},	{869,2},	{681,0},	{792,0},
  {829,0},	{866,0},	{903,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{867,0},
  {904,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {755,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{718,0},	{906,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0}
};

static struct patval fusekipat49[] = {
  {686,2},	{684,2},	{871,2},	{869,2},
  {830,0},	{756,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {719,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{793,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {682,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{867,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{873,0}
};

static struct patval fusekipat50[] = {
  {501,1},	{686,1},	{684,1},	{571,0},
  {645,0},	{534,0},	{498,0},	{535,0},
  {572,0},	{609,0},	{646,0},	{683,0},
  {499,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{608,0},	{500,0},	{537,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {497,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{682,0},	{502,0},	{539,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {503,0},	{540,0},	{577,0},	{614,0},
  {651,0},	{688,0}
};

static struct patval fusekipat51[] = {
  {684,1},	{723,2},	{797,4},	{833,4},
  {832,4},	{795,4},	{834,4},	{796,4},
  {759,0},	{721,0},	{686,0},	{685,0},
  {760,0},	{758,0},	{722,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0}
};

static struct patval fusekipat52[] = {
  {684,2},	{758,3},	{757,3},	{496,4},
  {498,4},	{535,4},	{533,4},	{534,4},
  {497,4},	{755,0},	{571,0},	{608,0},
  {645,0},	{718,0},	{719,0},	{756,0},
  {644,0},	{681,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{570,0},
  {499,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{682,0},	{721,0},	{607,0},
  {500,0},	{537,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {501,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0}
};

static struct patval fusekipat53[] = {
  {684,1},	{722,1},	{759,2},	{943,4},
  {907,4},	{944,4},	{942,4},	{869,4},
  {906,4},	{870,4},	{795,0},	{832,0},
  {794,0},	{721,0},	{757,0},	{685,0},
  {758,0},	{720,0},	{796,0},	{833,0},
  {831,0},	{868,0},	{905,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0}
};

static struct patval fusekipat54[] = {
  {684,2},	{499,3},	{758,3},	{795,3},
  {794,3},	{757,3},	{498,3},	{683,0},
  {646,0},	{535,0},	{536,0},	{573,0},
  {610,0},	{647,0},	{720,0},	{721,0},
  {572,0},	{609,0},	{500,0},	{537,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0}
};

static struct patval fusekipat55[] = {
  {684,2},	{869,3},	{868,3},	{870,3},
  {794,0},	{831,0},	{720,0},	{647,0},
  {683,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{646,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {757,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0}
};

static struct patval fusekipat56[] = {
  {685,2},	{684,2},	{683,4},	{572,0},
  {461,0},	{646,0},	{535,0},	{462,0},
  {499,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{498,0},	{463,0},	{500,0},
  {537,0},	{574,0},	{611,0},	{648,0},
  {609,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval fusekipat57[] = {
  {685,2},	{684,2},	{683,4},	{572,0},
  {461,0},	{646,0},	{535,0},	{462,0},
  {499,0},	{536,0},	{573,0},	{610,0},
  {647,0},	{498,0},	{463,0},	{500,0},
  {537,0},	{574,0},	{611,0},	{648,0},
  {609,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval fusekipat58[] = {
  {684,2},	{463,2},	{685,2},	{683,4},
  {646,0},	{572,0},	{462,0},	{499,0},
  {536,0},	{573,0},	{610,0},	{647,0},
  {498,0},	{535,0},	{500,0},	{537,0},
  {574,0},	{611,0},	{648,0},	{609,0},
  {464,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {465,0},	{502,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval fusekipat59[] = {
  {684,2},	{645,0},	{719,0},	{756,0},
  {793,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{647,0},
  {682,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0}
};

static struct patval fusekipat60[] = {
  {684,2},	{647,4},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{646,0},
  {683,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0}
};

static struct patval fusekipat61[] = {
  {684,2},	{719,0},	{682,0},	{793,0},
  {830,0},	{867,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{942,0},	{647,0},
  {756,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0}
};

static struct patval fusekipat62[] = {
  {684,2},	{646,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{647,0},	{683,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static struct patval fusekipat63[] = {
  {684,2},	{609,3},	{613,3},	{611,3},
  {576,3},	{574,3},	{575,3},	{612,3},
  {573,3},	{610,3},	{572,3},	{647,0},
  {721,0},	{758,0},	{795,0},	{720,0},
  {757,0},	{683,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {794,0},	{831,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{832,0},	{646,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval fusekipat64[] = {
  {684,2},	{538,3},	{539,3},	{537,3},
  {536,3},	{869,3},	{906,3},	{535,3},
  {794,0},	{683,0},	{573,0},	{610,0},
  {647,0},	{831,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{720,0},	{757,0},
  {646,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{572,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {609,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval fusekipat65[] = {
  {684,2},	{906,2},	{533,3},	{535,3},
  {940,3},	{536,3},	{538,3},	{539,3},
  {904,3},	{941,3},	{903,3},	{537,3},
  {534,3},	{571,0},	{681,0},	{755,0},
  {682,0},	{719,0},	{756,0},	{866,0},
  {830,0},	{867,0},	{570,0},	{718,0},
  {644,0},	{572,0},	{609,0},	{646,0},
  {683,0},	{720,0},	{757,0},	{645,0},
  {831,0},	{868,0},	{905,0},	{608,0},
  {573,0},	{610,0},	{647,0},	{607,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{829,0},	{943,0},	{793,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{794,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{792,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0}
};

static struct patval fusekipat66[] = {
  {684,2},	{981,3},	{980,3},	{943,3},
  {907,3},	{944,3},	{905,3},	{942,3},
  {979,3},	{906,3},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{794,0},
  {720,0},	{757,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {831,0},	{868,0},	{683,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0}
};

static struct patval fusekipat67[] = {
  {684,2},	{942,3},	{979,3},	{980,3},
  {906,3},	{943,3},	{904,3},	{941,3},
  {978,3},	{905,3},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{683,0},
  {719,0},	{756,0},	{793,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {830,0},	{867,0},	{682,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{944,0},	{981,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0}
};

static struct patval fusekipat68[] = {
  {684,2},	{906,2},	{831,0},	{757,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{794,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0}
};

static struct patval fusekipat69[] = {
  {684,1},	{649,2},	{647,3},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{612,0},	{721,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0}
};

static struct patval fusekipat70[] = {
  {684,2},	{571,0},	{534,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{793,0},
  {830,0},	{535,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{536,0},	{573,0},
  {610,0},	{647,0},	{608,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{537,0},
  {574,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {538,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0}
};

static struct patval fusekipat71[] = {
  {684,2},	{906,2},	{606,0},	{680,0},
  {717,0},	{754,0},	{791,0},	{569,0},
  {865,0},	{902,0},	{570,0},	{607,0},
  {644,0},	{681,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{866,0},	{903,0},
  {571,0},	{608,0},	{645,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{868,0},	{905,0},
  {573,0},	{610,0},	{647,0},	{828,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{643,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat72[] = {
  {723,2},	{684,2},	{945,2},	{719,0},
  {756,0},	{793,0},	{830,0},	{608,0},
  {904,0},	{941,0},	{609,0},	{646,0},
  {683,0},	{720,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {610,0},	{647,0},	{645,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {906,0},	{943,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {612,0},	{649,0},	{686,0},	{867,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{682,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{947,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {837,0},	{874,0},	{911,0},	{948,0}
};

static struct patval fusekipat73[] = {
  {945,2},	{684,2},	{724,2},	{723,2},
  {756,0},	{793,0},	{830,0},	{682,0},
  {719,0},	{941,0},	{978,0},	{1015,0},
  {1052,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{942,0},	{979,0},
  {1016,0},	{1053,0},	{610,0},	{647,0},
  {645,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{1054,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{1018,0},	{1055,0},
  {612,0},	{649,0},	{686,0},	{904,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{608,0},	{982,0},	{1019,0},
  {1056,0},	{613,0},	{650,0},	{687,0},
  {867,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0},	{983,0},
  {1020,0},	{1057,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{873,0},	{910,0},	{947,0},
  {984,0},	{1021,0},	{1058,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0},	{874,0},	{911,0},
  {948,0},	{985,0},	{1022,0},	{1059,0}
};

static struct patval fusekipat74[] = {
  {945,2},	{684,2},	{724,2},	{723,2},
  {946,2},	{793,0},	{830,0},	{682,0},
  {719,0},	{941,0},	{978,0},	{1015,0},
  {1052,0},	{756,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {868,0},	{905,0},	{942,0},	{979,0},
  {1016,0},	{1053,0},	{610,0},	{647,0},
  {645,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{1054,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{1018,0},	{1055,0},
  {612,0},	{649,0},	{686,0},	{904,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{608,0},	{982,0},	{1019,0},
  {1056,0},	{613,0},	{650,0},	{687,0},
  {867,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{609,0},	{983,0},
  {1020,0},	{1057,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{873,0},	{910,0},	{947,0},
  {984,0},	{1021,0},	{1058,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0},	{874,0},	{911,0},
  {948,0},	{985,0},	{1022,0},	{1059,0}
};

static struct patval fusekipat75[] = {
  {611,1},	{684,1},	{685,2},	{722,2},
  {647,3},	{610,3},	{612,3},	{648,3},
  {907,3},	{906,0},	{869,0},	{758,0},
  {721,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{795,0},	{832,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat76[] = {
  {611,1},	{684,1},	{907,2},	{722,2},
  {685,2},	{610,3},	{612,3},	{648,3},
  {647,3},	{906,0},	{869,0},	{758,0},
  {721,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{795,0},	{832,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat77[] = {
  {684,1},	{870,2},	{758,0},	{721,0},
  {832,0},	{869,0},	{906,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {795,0},	{907,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat78[] = {
  {684,1},	{869,2},	{720,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{757,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {683,0},	{906,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0}
};

static struct patval fusekipat79[] = {
  {684,2},	{722,2},	{426,3},	{463,3},
  {425,3},	{462,3},	{647,0},	{573,0},
  {721,0},	{499,0},	{536,0},	{500,0},
  {537,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{610,0},	{427,0},	{464,0},
  {501,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{428,0},
  {465,0},	{502,0},	{539,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0}
};

static struct patval fusekipat80[] = {
  {870,1},	{684,2},	{720,0},	{757,0},
  {646,0},	{831,0},	{868,0},	{647,0},
  {683,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {794,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0}
};

static struct patval fusekipat81[] = {
  {869,1},	{684,2},	{870,3},	{685,4},
  {831,0},	{868,0},	{757,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{683,0},
  {720,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{794,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0}
};

static struct patval fusekipat82[] = {
  {684,1},	{685,1},	{758,2},	{722,2},
  {535,0},	{720,0},	{757,0},	{536,0},
  {573,0},	{610,0},	{647,0},	{683,0},
  {721,0},	{572,0},	{537,0},	{574,0},
  {611,0},	{648,0},	{609,0},	{646,0},
  {759,0},	{538,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {539,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval fusekipat83[] = {
  {758,1},	{684,2},	{980,4},	{979,4},
  {831,0},	{868,0},	{905,0},	{942,0},
  {794,0},	{683,0},	{721,0},	{757,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{720,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{981,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0}
};

static struct patval fusekipat84[] = {
  {684,2},	{832,2},	{756,3},	{682,3},
  {719,3},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{793,0},	{721,0},
  {758,0},	{795,0},	{830,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval fusekipat85[] = {
  {684,1},	{1055,3},	{1092,3},	{685,3},
  {1091,3},	{1054,3},	{906,0},	{943,0},
  {980,0},	{1017,0},	{869,0},	{832,0},
  {795,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{721,0},	{758,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{1093,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0},	{1020,0},	{1057,0},	{1094,0}
};

static struct patval fusekipat86[] = {
  {684,1},	{1054,3},	{1091,3},	{683,3},
  {1090,3},	{1053,3},	{905,0},	{942,0},
  {979,0},	{1016,0},	{868,0},	{831,0},
  {794,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{720,0},	{757,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{1092,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{1093,0}
};

static struct patval fusekipat87[] = {
  {684,1},	{980,1},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {721,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0},	{982,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0},	{946,0},	{983,0}
};

static struct patval fusekipat88[] = {
  {684,1},	{870,1},	{757,0},	{794,0},
  {720,0},	{647,0},	{683,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{831,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval fusekipat89[] = {
  {684,1},	{907,1},	{757,0},	{794,0},
  {720,0},	{868,0},	{647,0},	{683,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{831,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0},	{909,0}
};

static struct patval fusekipat90[] = {
  {796,1},	{684,2},	{906,2},	{795,2},
  {685,4},	{686,4},	{869,0},	{832,0},
  {722,0},	{759,0},	{721,0},	{833,0},
  {870,0},	{907,0},	{758,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat91[] = {
  {684,1},	{870,1},	{759,2},	{756,0},
  {830,0},	{867,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{682,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {685,0},	{722,0},	{793,0},	{796,0},
  {833,0},	{719,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0}
};

static struct patval fusekipat92[] = {
  {686,1},	{684,1},	{1018,4},	{1019,4},
  {1056,4},	{1055,4},	{795,0},	{721,0},
  {869,0},	{610,0},	{943,0},	{980,0},
  {1017,0},	{758,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{647,0},	{1054,0},
  {575,0},	{612,0},	{649,0},	{832,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {906,0},	{573,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0},	{983,0},	{1020,0},	{1057,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0},
  {1021,0},	{1058,0}
};

static struct patval fusekipat93[] = {
  {686,1},	{684,1},	{1018,4},	{1019,4},
  {1056,4},	{1055,4},	{795,0},	{721,0},
  {869,0},	{610,0},	{943,0},	{980,0},
  {1017,0},	{758,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {944,0},	{981,0},	{647,0},	{1054,0},
  {575,0},	{612,0},	{649,0},	{832,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {906,0},	{573,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0},	{983,0},	{1020,0},	{1057,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0},
  {1021,0},	{1058,0}
};

static struct patval fusekipat94[] = {
  {723,1},	{684,1},	{1056,4},	{1092,4},
  {1055,4},	{1093,4},	{832,0},	{795,0},
  {758,0},	{647,0},	{980,0},	{1017,0},
  {1054,0},	{1091,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{906,0},	{721,0},
  {612,0},	{649,0},	{686,0},	{869,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0},	{982,0},	{1019,0},
  {943,0},	{610,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0},	{1020,0},	{1057,0},	{1094,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{947,0},	{984,0},	{1021,0},
  {1058,0},	{1095,0}
};

static struct patval fusekipat95[] = {
  {723,1},	{684,1},	{1056,4},	{1092,4},
  {1055,4},	{1093,4},	{832,0},	{795,0},
  {758,0},	{647,0},	{980,0},	{1017,0},
  {1054,0},	{1091,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{906,0},	{721,0},
  {612,0},	{649,0},	{686,0},	{869,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {908,0},	{945,0},	{982,0},	{1019,0},
  {943,0},	{610,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0},	{1020,0},	{1057,0},	{1094,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{947,0},	{984,0},	{1021,0},
  {1058,0},	{1095,0}
};

static struct patval fusekipat96[] = {
  {758,1},	{684,1},	{1055,4},	{1091,4},
  {1092,4},	{1054,4},	{831,0},	{868,0},
  {905,0},	{646,0},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{610,0},	{647,0},
  {794,0},	{721,0},	{757,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{683,0},	{720,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{981,0},	{1018,0},
  {942,0},	{609,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{1093,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0}
};

static struct patval fusekipat97[] = {
  {684,1},	{759,1},	{1092,4},	{1091,4},
  {1055,4},	{1054,4},	{757,0},	{868,0},
  {905,0},	{831,0},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{610,0},	{647,0},
  {794,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{1017,0},	{683,0},	{720,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {646,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{944,0},	{981,0},	{1018,0},
  {942,0},	{609,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{1093,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0}
};

static struct patval fusekipat98[] = {
  {1128,1},	{684,1},	{571,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{608,0},
  {1015,0},	{1052,0},	{1089,0},	{1126,0},
  {1163,0},	{1200,0},	{1237,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{1127,0},	{1164,0},
  {1201,0},	{1238,0},	{573,0},	{610,0},
  {647,0},	{978,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{980,0},	{1017,0},	{1054,0},
  {1091,0},	{645,0},	{1165,0},	{1202,0},
  {1239,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{1092,0},
  {1129,0},	{1166,0},	{1203,0},	{1240,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {1019,0},	{1056,0},	{1093,0},	{1130,0},
  {1167,0},	{1204,0},	{1241,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0},	{1131,0},	{1168,0},
  {1205,0},	{1242,0}
};

static struct patval fusekipat99[] = {
  {1128,1},	{684,1},	{571,0},	{682,0},
  {719,0},	{756,0},	{793,0},	{830,0},
  {867,0},	{904,0},	{941,0},	{608,0},
  {1015,0},	{1052,0},	{1089,0},	{1126,0},
  {1163,0},	{1200,0},	{1237,0},	{572,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{1127,0},	{1164,0},
  {1201,0},	{1238,0},	{573,0},	{610,0},
  {647,0},	{978,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{980,0},	{1017,0},	{1054,0},
  {1091,0},	{645,0},	{1165,0},	{1202,0},
  {1239,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{1018,0},	{1055,0},	{1092,0},
  {1129,0},	{1166,0},	{1203,0},	{1240,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {1019,0},	{1056,0},	{1093,0},	{1130,0},
  {1167,0},	{1204,0},	{1241,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0},	{1131,0},	{1168,0},
  {1205,0},	{1242,0}
};

static struct patval fusekipat100[] = {
  {686,1},	{684,1},	{1018,3},	{981,3},
  {982,3},	{1055,3},	{1019,3},	{1056,3},
  {907,4},	{908,4},	{721,0},	{980,0},
  {1017,0},	{943,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{870,0},	{758,0},
  {944,0},	{610,0},	{647,0},	{1054,0},
  {575,0},	{612,0},	{649,0},	{832,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{795,0},	{945,0},	{869,0},
  {906,0},	{573,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {946,0},	{983,0},	{1020,0},	{1057,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0},
  {1021,0},	{1058,0}
};

static struct patval fusekipat101[] = {
  {723,1},	{684,1},	{1055,3},	{1018,3},
  {1092,3},	{1056,3},	{1093,3},	{1019,3},
  {945,4},	{944,4},	{832,0},	{980,0},
  {1017,0},	{1054,0},	{721,0},	{574,0},
  {611,0},	{648,0},	{943,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{758,0},	{981,0},	{610,0},
  {647,0},	{685,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{1091,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {795,0},	{982,0},	{869,0},	{906,0},
  {573,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{909,0},	{946,0},
  {983,0},	{1020,0},	{1057,0},	{1094,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0},
  {1021,0},	{1058,0},	{1095,0}
};

static struct patval fusekipat102[] = {
  {684,1},	{944,2},	{759,3},	{1091,3},
  {758,3},	{1054,3},	{1092,3},	{1017,3},
  {1018,3},	{1055,3},	{979,0},	{1016,0},
  {1053,0},	{1090,0},	{610,0},	{647,0},
  {794,0},	{721,0},	{757,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{943,0},
  {980,0},	{868,0},	{683,0},	{720,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {646,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{831,0},	{981,0},	{905,0},
  {942,0},	{609,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {982,0},	{1019,0},	{1056,0},	{1093,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0},	{1020,0},
  {1057,0},	{1094,0}
};

static struct patval fusekipat103[] = {
  {684,1},	{648,1},	{611,2},	{500,2},
  {682,3},	{683,3},	{460,0},	{461,0},
  {498,0},	{571,0},	{572,0},	{609,0},
  {646,0},	{645,0},	{462,0},	{499,0},
  {536,0},	{573,0},	{610,0},	{647,0},
  {535,0},	{463,0},	{608,0},	{537,0},
  {574,0},	{497,0},	{534,0},	{685,0},
  {464,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{465,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval fusekipat104[] = {
  {684,1},	{648,1},	{611,2},	{682,3},
  {683,3},	{462,4},	{463,4},	{608,0},
  {498,0},	{461,0},	{572,0},	{609,0},
  {646,0},	{645,0},	{460,0},	{499,0},
  {536,0},	{573,0},	{610,0},	{647,0},
  {535,0},	{571,0},	{500,0},	{537,0},
  {574,0},	{497,0},	{534,0},	{685,0},
  {464,0},	{501,0},	{538,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{465,0},
  {502,0},	{539,0},	{576,0},	{613,0},
  {650,0},	{687,0}
};

static struct patval fusekipat105[] = {
  {685,1},	{684,2},	{758,3},	{609,0},
  {720,0},	{573,0},	{610,0},	{647,0},
  {572,0},	{721,0},	{646,0},	{574,0},
  {611,0},	{648,0},	{683,0},	{722,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval fusekipat106[] = {
  {684,1},	{686,2},	{646,0},	{572,0},
  {720,0},	{757,0},	{794,0},	{573,0},
  {610,0},	{647,0},	{609,0},	{721,0},
  {758,0},	{795,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{575,0},	{612,0},	{649,0},
  {683,0},	{723,0},	{760,0},	{797,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{578,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0}
};

static struct patval fusekipat107[] = {
  {684,1},	{687,2},	{646,0},	{683,0},
  {572,0},	{610,0},	{647,0},	{609,0},
  {721,0},	{758,0},	{795,0},	{574,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{723,0},	{760,0},
  {797,0},	{576,0},	{613,0},	{650,0},
  {573,0},	{724,0},	{761,0},	{798,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{578,0},
  {615,0},	{652,0},	{689,0},	{726,0},
  {763,0},	{800,0},	{579,0},	{616,0},
  {653,0},	{690,0},	{727,0},	{764,0},
  {801,0}
};

static struct patval fusekipat108[] = {
  {684,1},	{724,2},	{683,0},	{720,0},
  {646,0},	{647,0},	{609,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{613,0},	{650,0},	{687,0},
  {610,0},	{761,0},	{798,0},	{835,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0},	{616,0},	{653,0},
  {690,0},	{727,0},	{764,0},	{801,0},
  {838,0}
};

static struct patval fusekipat109[] = {
  {649,1},	{684,1},	{723,2},	{797,2},
  {611,0},	{685,0},	{722,0},	{759,0},
  {796,0},	{612,0},	{648,0},	{686,0},
  {647,0},	{760,0},	{610,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0}
};

static struct patval fusekipat110[] = {
  {723,1},	{798,2},	{684,2},	{683,0},
  {757,0},	{646,0},	{831,0},	{610,0},
  {647,0},	{609,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{612,0},	{649,0},	{686,0},
  {720,0},	{760,0},	{797,0},	{834,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{794,0},	{835,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {837,0}
};

static struct patval fusekipat111[] = {
  {648,1},	{684,2},	{645,0},	{608,0},
  {571,0},	{756,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {573,0},	{610,0},	{647,0},	{682,0},
  {721,0},	{758,0},	{574,0},	{611,0},
  {719,0},	{685,0},	{722,0},	{759,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval fusekipat112[] = {
  {723,1},	{684,1},	{648,2},	{645,0},
  {571,0},	{572,0},	{609,0},	{646,0},
  {683,0},	{720,0},	{573,0},	{610,0},
  {647,0},	{719,0},	{721,0},	{574,0},
  {611,0},	{608,0},	{685,0},	{722,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {682,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0}
};

static struct patval fusekipat113[] = {
  {648,1},	{684,1},	{759,2},	{686,2},
  {795,0},	{832,0},	{869,0},	{906,0},
  {721,0},	{685,0},	{722,0},	{647,0},
  {796,0},	{833,0},	{870,0},	{907,0},
  {649,0},	{758,0},	{723,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{908,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0}
};

static struct patval fusekipat114[] = {
  {723,1},	{684,1},	{678,3},	{982,3},
  {981,3},	{945,3},	{717,3},	{643,3},
  {641,3},	{642,3},	{679,3},	{716,3},
  {909,3},	{946,3},	{983,3},	{907,3},
  {715,3},	{908,3},	{680,3},	{944,3},
  {754,0},	{863,0},	{789,0},	{604,0},
  {607,0},	{864,0},	{826,0},	{752,0},
  {755,0},	{792,0},	{829,0},	{866,0},
  {903,0},	{940,0},	{977,0},	{608,0},
  {645,0},	{682,0},	{719,0},	{756,0},
  {793,0},	{830,0},	{867,0},	{904,0},
  {941,0},	{978,0},	{609,0},	{646,0},
  {683,0},	{720,0},	{757,0},	{794,0},
  {831,0},	{868,0},	{905,0},	{942,0},
  {979,0},	{610,0},	{647,0},	{605,0},
  {721,0},	{758,0},	{795,0},	{832,0},
  {869,0},	{906,0},	{943,0},	{980,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {644,0},	{681,0},	{718,0},	{612,0},
  {649,0},	{686,0},	{606,0},	{760,0},
  {797,0},	{834,0},	{871,0},	{791,0},
  {828,0},	{865,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{798,0},
  {835,0},	{872,0},	{753,0},	{790,0},
  {827,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{910,0},	{947,0},	{984,0}
};

static struct patval fusekipat115[] = {
  {684,1},	{648,2},	{685,3},	{645,0},
  {719,0},	{572,0},	{609,0},	{646,0},
  {683,0},	{720,0},	{573,0},	{610,0},
  {647,0},	{682,0},	{721,0},	{574,0},
  {611,0},	{571,0},	{608,0},	{722,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0}
};

static struct patval fusekipat116[] = {
  {684,1},	{758,2},	{645,0},	{719,0},
  {756,0},	{793,0},	{830,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {794,0},	{831,0},	{610,0},	{647,0},
  {682,0},	{721,0},	{608,0},	{795,0},
  {832,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0}
};

static struct patval fusekipat117[] = {
  {684,1},	{649,1},	{798,2},	{723,2},
  {757,0},	{683,0},	{831,0},	{610,0},
  {647,0},	{609,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{611,0},	{648,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{612,0},	{646,0},	{686,0},
  {720,0},	{760,0},	{797,0},	{834,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{794,0},	{835,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {837,0}
};

static struct patval fusekipat118[] = {
  {759,1},	{684,2},	{680,0},	{717,0},
  {754,0},	{643,0},	{606,0},	{607,0},
  {644,0},	{681,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{793,0},
  {830,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {610,0},	{647,0},	{791,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{828,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval fusekipat119[] = {
  {759,1},	{684,2},	{680,0},	{717,0},
  {754,0},	{643,0},	{606,0},	{607,0},
  {644,0},	{681,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{793,0},
  {830,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {610,0},	{647,0},	{791,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{828,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval fusekipat120[] = {
  {759,1},	{684,2},	{680,0},	{717,0},
  {754,0},	{643,0},	{606,0},	{607,0},
  {644,0},	{681,0},	{718,0},	{755,0},
  {792,0},	{829,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{793,0},
  {830,0},	{609,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{831,0},
  {610,0},	{647,0},	{791,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{828,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0}
};

static struct patval fusekipat121[] = {
  {759,1},	{684,2},	{943,4},	{944,4},
  {681,0},	{792,0},	{829,0},	{866,0},
  {607,0},	{940,0},	{608,0},	{645,0},
  {682,0},	{719,0},	{756,0},	{755,0},
  {830,0},	{867,0},	{904,0},	{941,0},
  {609,0},	{646,0},	{683,0},	{720,0},
  {757,0},	{794,0},	{831,0},	{868,0},
  {905,0},	{942,0},	{610,0},	{647,0},
  {644,0},	{721,0},	{758,0},	{795,0},
  {832,0},	{869,0},	{906,0},	{793,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {718,0},	{796,0},	{833,0},	{870,0},
  {907,0},	{903,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{945,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0}
};

static struct patval fusekipat122[] = {
  {684,1},	{686,2},	{759,2},	{647,0},
  {721,0},	{758,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{573,0},
  {575,0},	{612,0},	{649,0},	{610,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval fusekipat123[] = {
  {796,1},	{684,1},	{758,1},	{759,2},
  {795,2},	{757,0},	{646,0},	{831,0},
  {868,0},	{573,0},	{610,0},	{647,0},
  {609,0},	{721,0},	{794,0},	{572,0},
  {832,0},	{869,0},	{574,0},	{611,0},
  {648,0},	{685,0},	{722,0},	{683,0},
  {720,0},	{833,0},	{870,0},	{575,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {872,0}
};

static struct patval fusekipat124[] = {
  {797,1},	{722,1},	{759,1},	{684,1},
  {760,2},	{723,2},	{686,2},	{685,2},
  {683,3},	{721,3},	{796,3},	{833,3},
  {720,3},	{648,0},	{649,0},	{647,0},
  {646,0},	{834,0},	{871,0},	{908,0},
  {650,0},	{687,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{872,0},	{909,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0},	{873,0},	{910,0}
};

static struct patval fusekipat125[] = {
  {688,1},	{723,1},	{684,1},	{687,1},
  {724,2},	{798,2},	{725,2},	{685,0},
  {610,0},	{796,0},	{612,0},	{649,0},
  {686,0},	{722,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{721,0},	{759,0},
  {761,0},	{647,0},	{614,0},	{651,0},
  {611,0},	{648,0},	{762,0},	{799,0},
  {615,0},	{652,0},	{689,0},	{726,0},
  {763,0},	{800,0}
};

static struct patval fusekipat126[] = {
  {688,1},	{726,1},	{684,1},	{687,1},
  {723,1},	{798,2},	{725,2},	{762,2},
  {724,2},	{647,3},	{796,0},	{649,0},
  {686,0},	{722,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{721,0},	{759,0},
  {761,0},	{685,0},	{614,0},	{651,0},
  {611,0},	{612,0},	{610,0},	{799,0},
  {615,0},	{652,0},	{689,0},	{648,0},
  {763,0},	{800,0}
};

static struct patval fusekipat127[] = {
  {684,1},	{649,1},	{687,2},	{723,2},
  {611,0},	{648,0},	{685,0},	{722,0},
  {612,0},	{647,0},	{686,0},	{721,0},
  {613,0},	{650,0},	{610,0},	{724,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {615,0},	{652,0},	{689,0},	{726,0}
};

static struct patval fusekipat128[] = {
  {758,1},	{684,1},	{723,2},	{721,0},
  {610,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{647,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0}
};

static struct patval fusekipat129[] = {
  {723,1},	{758,2},	{684,2},	{647,0},
  {610,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{721,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {615,0},	{652,0},	{689,0},	{726,0},
  {763,0},	{800,0},	{837,0},	{874,0}
};

static struct patval fusekipat130[] = {
  {758,1},	{684,1},	{723,2},	{647,0},
  {610,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{721,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {615,0},	{652,0},	{689,0},	{726,0},
  {763,0},	{800,0},	{837,0},	{874,0}
};

static struct patval fusekipat131[] = {
  {684,1},	{687,1},	{723,2},	{724,2},
  {611,0},	{721,0},	{685,0},	{722,0},
  {612,0},	{649,0},	{686,0},	{610,0},
  {760,0},	{613,0},	{650,0},	{647,0},
  {648,0},	{761,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{615,0},	{652,0},	{689,0},
  {726,0},	{763,0},	{800,0},	{837,0}
};

static struct patval fusekipat132[] = {
  {684,1},	{724,2},	{647,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{685,0},	{722,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{686,0},	{723,0},
  {760,0},	{613,0},	{650,0},	{687,0},
  {610,0},	{761,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0},
  {836,0},	{873,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {837,0},	{874,0}
};

static struct patval fusekipat133[] = {
  {722,1},	{759,1},	{760,1},	{798,1},
  {684,1},	{761,2},	{723,2},	{685,2},
  {686,2},	{720,3},	{721,3},	{835,3},
  {683,3},	{649,0},	{650,0},	{687,0},
  {724,0},	{648,0},	{647,0},	{646,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{836,0}
};

static struct patval fusekipat134[] = {
  {686,1},	{722,1},	{685,2},	{684,2},
  {611,2},	{610,0},	{609,0},	{720,0},
  {721,0},	{758,0},	{647,0},	{648,0},
  {646,0},	{683,0},	{759,0},	{575,0},
  {612,0},	{649,0},	{757,0},	{723,0},
  {760,0},	{576,0},	{613,0},	{650,0},
  {687,0},	{724,0},	{761,0},	{577,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0}
};

static struct patval fusekipat135[] = {
  {724,1},	{761,1},	{797,1},	{684,1},
  {759,2},	{760,2},	{687,2},	{686,2},
  {721,0},	{574,0},	{647,0},	{648,0},
  {685,0},	{722,0},	{869,0},	{796,0},
  {833,0},	{870,0},	{575,0},	{612,0},
  {649,0},	{832,0},	{723,0},	{758,0},
  {611,0},	{834,0},	{871,0},	{576,0},
  {613,0},	{650,0},	{795,0},	{573,0},
  {610,0},	{798,0},	{835,0},	{872,0},
  {577,0},	{614,0},	{651,0},	{688,0},
  {725,0},	{762,0},	{799,0},	{836,0},
  {873,0},	{578,0},	{615,0},	{652,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {837,0},	{874,0}
};

static struct patval fusekipat136[] = {
  {872,1},	{649,1},	{684,1},	{798,2},
  {723,2},	{687,2},	{832,0},	{758,0},
  {610,0},	{611,0},	{648,0},	{685,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {870,0},	{907,0},	{612,0},	{906,0},
  {686,0},	{869,0},	{760,0},	{797,0},
  {834,0},	{871,0},	{908,0},	{613,0},
  {650,0},	{795,0},	{724,0},	{761,0},
  {647,0},	{835,0},	{721,0},	{909,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{615,0},	{652,0},	{689,0},
  {726,0},	{763,0},	{800,0},	{837,0},
  {874,0},	{911,0}
};

static struct patval fusekipat137[] = {
  {722,1},	{686,1},	{684,1},	{723,2},
  {687,2},	{798,4},	{835,4},	{611,0},
  {647,0},	{685,0},	{758,0},	{759,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {610,0},	{832,0},	{760,0},	{797,0},
  {834,0},	{613,0},	{650,0},	{795,0},
  {724,0},	{761,0},	{648,0},	{721,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0}
};

static struct patval fusekipat138[] = {
  {722,1},	{686,1},	{684,1},	{723,2},
  {687,2},	{797,2},	{832,0},	{611,0},
  {610,0},	{685,0},	{758,0},	{759,0},
  {796,0},	{833,0},	{612,0},	{649,0},
  {648,0},	{721,0},	{760,0},	{647,0},
  {834,0},	{613,0},	{650,0},	{795,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0}
};

static struct patval fusekipat139[] = {
  {722,1},	{686,1},	{684,1},	{723,2},
  {687,2},	{797,2},	{649,2},	{685,3},
  {648,3},	{611,0},	{832,0},	{759,0},
  {796,0},	{833,0},	{612,0},	{758,0},
  {610,0},	{721,0},	{760,0},	{647,0},
  {834,0},	{613,0},	{650,0},	{795,0},
  {724,0},	{761,0},	{798,0},	{835,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{615,0},
  {652,0},	{689,0},	{726,0},	{763,0},
  {800,0},	{837,0}
};

static struct patval fusekipat140[] = {
  {722,1},	{685,1},	{648,2},	{684,2},
  {682,4},	{645,4},	{683,4},	{608,0},
  {573,0},	{610,0},	{647,0},	{572,0},
  {574,0},	{611,0},	{609,0},	{646,0},
  {571,0},	{575,0},	{612,0},	{649,0},
  {686,0},	{723,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0}
};

static struct patval fusekipat141[] = {
  {760,1},	{759,1},	{684,2},	{723,2},
  {683,4},	{646,4},	{572,0},	{609,0},
  {574,0},	{611,0},	{647,0},	{685,0},
  {722,0},	{610,0},	{575,0},	{612,0},
  {649,0},	{686,0},	{648,0},	{573,0},
  {576,0},	{613,0},	{650,0},	{687,0},
  {724,0},	{761,0}
};

static struct patval fusekipat142[] = {
  {723,1},	{722,1},	{758,1},	{686,1},
  {685,2},	{759,2},	{721,2},	{684,2},
  {608,0},	{720,0},	{757,0},	{794,0},
  {610,0},	{647,0},	{645,0},	{682,0},
  {609,0},	{795,0},	{611,0},	{648,0},
  {646,0},	{683,0},	{793,0},	{796,0},
  {612,0},	{649,0},	{719,0},	{756,0},
  {760,0},	{797,0}
};

static struct patval fusekipat143[] = {
  {722,1},	{649,1},	{685,1},	{613,1},
  {650,1},	{686,2},	{612,2},	{611,2},
  {648,2},	{684,2},	{647,0},	{720,0},
  {721,0},	{758,0},	{537,0},	{574,0},
  {535,0},	{572,0},	{757,0},	{536,0},
  {759,0},	{538,0},	{575,0},	{609,0},
  {573,0},	{610,0},	{723,0},	{760,0},
  {539,0},	{576,0},	{646,0},	{683,0},
  {687,0},	{724,0},	{761,0}
};

static struct patval fusekipat144[] = {
  {872,1},	{684,1},	{723,2},	{797,2},
  {870,3},	{721,3},	{686,4},	{687,4},
  {685,4},	{647,0},	{758,0},	{610,0},
  {722,0},	{759,0},	{796,0},	{833,0},
  {906,0},	{907,0},	{612,0},	{649,0},
  {832,0},	{869,0},	{760,0},	{611,0},
  {834,0},	{871,0},	{908,0},	{613,0},
  {650,0},	{795,0},	{724,0},	{761,0},
  {798,0},	{835,0},	{648,0},	{909,0},
  {614,0},	{651,0},	{688,0},	{725,0},
  {762,0},	{799,0},	{836,0},	{873,0},
  {910,0},	{615,0},	{652,0},	{689,0},
  {726,0},	{763,0},	{800,0},	{837,0},
  {874,0},	{911,0}
};

static struct patval fusekipat145[] = {
  {685,1},	{684,1},	{759,2},	{648,2},
  {608,0},	{756,0},	{572,0},	{609,0},
  {646,0},	{683,0},	{720,0},	{757,0},
  {573,0},	{610,0},	{647,0},	{682,0},
  {721,0},	{758,0},	{574,0},	{611,0},
  {719,0},	{571,0},	{722,0},	{645,0},
  {575,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{576,0},	{613,0},
  {650,0},	{687,0},	{724,0},	{761,0}
};

static struct patval fusekipat146[] = {
  {721,1},	{652,1},	{684,1},	{654,2},
  {722,2},	{649,2},	{759,2},	{648,0},
  {611,0},	{573,0},	{610,0},	{796,0},
  {575,0},	{612,0},	{574,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{576,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{577,0},	{614,0},
  {651,0},	{688,0},	{725,0},	{762,0},
  {799,0},	{578,0},	{615,0},	{685,0},
  {689,0},	{726,0},	{763,0},	{800,0},
  {579,0},	{616,0},	{653,0},	{690,0},
  {727,0},	{764,0},	{801,0},	{580,0},
  {617,0},	{647,0},	{691,0},	{728,0},
  {765,0},	{802,0},	{581,0},	{618,0},
  {655,0},	{692,0},	{729,0},	{766,0},
  {803,0}
};

static struct patval fusekipat147[] = {
  {795,1},	{721,1},	{684,1},	{759,2},
  {649,2},	{722,2},	{761,3},	{798,3},
  {724,3},	{687,3},	{608,0},	{720,0},
  {757,0},	{794,0},	{609,0},	{610,0},
  {647,0},	{645,0},	{682,0},	{758,0},
  {646,0},	{574,0},	{611,0},	{648,0},
  {685,0},	{573,0},	{571,0},	{796,0},
  {575,0},	{612,0},	{683,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{576,0},
  {613,0},	{650,0},	{719,0},	{756,0},
  {793,0},	{572,0},	{577,0},	{614,0},
  {651,0}
};

static struct patval fusekipat148[] = {
  {648,1},	{686,1},	{685,2},	{723,2},
  {684,2},	{650,3},	{687,3},	{649,3},
  {759,0},	{796,0},	{833,0},	{722,0},
  {758,0},	{795,0},	{760,0},	{797,0},
  {834,0},	{832,0},	{721,0},	{724,0},
  {761,0},	{798,0},	{835,0}
};

static struct patval fusekipat149[] = {
  {684,2},	{648,2},	{611,4},	{683,4},
  {647,4},	{719,0},	{720,0},	{757,0},
  {794,0},	{830,0},	{868,0},	{905,0},
  {756,0},	{793,0},	{721,0},	{758,0},
  {795,0},	{832,0},	{869,0},	{906,0},
  {943,0},	{980,0},	{867,0},	{831,0},
  {685,0},	{722,0},	{759,0},	{796,0},
  {833,0},	{870,0},	{907,0},	{944,0},
  {981,0},	{612,0},	{649,0},	{686,0},
  {723,0},	{760,0},	{797,0},	{834,0},
  {871,0},	{908,0},	{945,0},	{982,0},
  {613,0},	{650,0},	{687,0},	{724,0},
  {761,0},	{798,0},	{835,0},	{872,0},
  {909,0},	{946,0},	{983,0}
};

static struct patval fusekipat150[] = {
  {722,1},	{684,1},	{686,1},	{687,2},
  {723,2},	{645,0},	{682,0},	{719,0},
  {792,0},	{793,0},	{646,0},	{683,0},
  {720,0},	{757,0},	{794,0},	{647,0},
  {681,0},	{721,0},	{758,0},	{795,0},
  {611,0},	{648,0},	{685,0},	{756,0},
  {759,0},	{796,0},	{612,0},	{649,0},
  {718,0},	{755,0},	{760,0},	{797,0},
  {613,0},	{650,0},	{644,0},	{724,0},
  {761,0},	{798,0},	{614,0},	{651,0},
  {688,0},	{725,0},	{762,0},	{799,0}
};

static struct patval fusekipat151[] = {
  {722,1},	{721,1},	{685,2},	{684,2},
  {795,2},	{723,3},	{686,4},	{756,0},
  {646,0},	{683,0},	{830,0},	{757,0},
  {794,0},	{831,0},	{610,0},	{647,0},
  {608,0},	{793,0},	{758,0},	{720,0},
  {832,0},	{611,0},	{648,0},	{609,0},
  {719,0},	{759,0},	{612,0},	{649,0},
  {645,0},	{682,0},	{760,0},	{613,0},
  {650,0},	{761,0},	{798,0},	{835,0}
};

static struct patval fusekipat152[] = {
  {686,1},	{685,1},	{721,1},	{648,2},
  {649,2},	{684,2},	{759,2},	{687,3},
  {650,4},	{647,0},	{794,0},	{720,0},
  {610,0},	{795,0},	{574,0},	{611,0},
  {572,0},	{757,0},	{722,0},	{758,0},
  {796,0},	{575,0},	{612,0},	{573,0},
  {683,0},	{723,0},	{576,0},	{613,0},
  {609,0},	{646,0},	{724,0},	{577,0},
  {614,0},	{725,0},	{762,0},	{799,0}
};

static struct patval fusekipat153[] = {
  {685,1},	{724,1},	{686,1},	{684,2},
  {722,2},	{794,0},	{720,0},	{868,0},
  {610,0},	{647,0},	{831,0},	{721,0},
  {758,0},	{795,0},	{832,0},	{869,0},
  {611,0},	{648,0},	{609,0},	{646,0},
  {759,0},	{796,0},	{833,0},	{870,0},
  {612,0},	{649,0},	{683,0},	{723,0},
  {760,0},	{797,0},	{834,0},	{871,0},
  {613,0},	{650,0},	{687,0},	{757,0},
  {761,0},	{798,0},	{835,0},	{872,0}
};

static int
autohelperfusekipat3(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(831, trans, move);
  b = AFFINE_TRANSFORM(832, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperfusekipat6(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(832, trans, move);
  b = AFFINE_TRANSFORM(833, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperfusekipat9(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(796, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperfusekipat26(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(796, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == OTHER_COLOR(color));
}

static int
autohelperfusekipat34(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(720, trans, move);

  return !(whose_moyo(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperfusekipat52(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(500, trans, move);
  b = AFFINE_TRANSFORM(537, trans, move);

  return  somewhere(color, 1, 2, a, b);
}

static int
autohelperfusekipat53(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(832, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(796, trans, move);
  e = AFFINE_TRANSFORM(833, trans, move);
  f = AFFINE_TRANSFORM(870, trans, move);

  return  somewhere(color, 1, 6, a, b, c, d, e, f);
}

static int
autohelperfusekipat54(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(906, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat58(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(685, trans, move);

  return !(whose_territory(OPPOSITE_INFLUENCE(color), move) == color) && !(whose_territory(OPPOSITE_INFLUENCE(color), a) == color);
}

static int
autohelperfusekipat63(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(461, trans, move);
  b = AFFINE_TRANSFORM(498, trans, move);
  c = AFFINE_TRANSFORM(462, trans, move);
  d = AFFINE_TRANSFORM(499, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat64(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(424, trans, move);
  b = AFFINE_TRANSFORM(425, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 2, a, b);
}

static int
autohelperfusekipat65(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(387, trans, move);
  b = AFFINE_TRANSFORM(388, trans, move);
  c = AFFINE_TRANSFORM(754, trans, move);
  d = AFFINE_TRANSFORM(791, trans, move);
  e = AFFINE_TRANSFORM(755, trans, move);
  f = AFFINE_TRANSFORM(792, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f);
}

static int
autohelperfusekipat66(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(794, trans, move);
  b = AFFINE_TRANSFORM(831, trans, move);
  c = AFFINE_TRANSFORM(795, trans, move);
  d = AFFINE_TRANSFORM(832, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat67(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(794, trans, move);
  b = AFFINE_TRANSFORM(831, trans, move);
  c = AFFINE_TRANSFORM(795, trans, move);
  d = AFFINE_TRANSFORM(832, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat79(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(572, trans, move);
  b = AFFINE_TRANSFORM(573, trans, move);
  c = AFFINE_TRANSFORM(609, trans, move);
  d = AFFINE_TRANSFORM(610, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat84(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(608, trans, move);
  b = AFFINE_TRANSFORM(645, trans, move);
  c = AFFINE_TRANSFORM(682, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 3, a, b, c);
}

static int
autohelperfusekipat85(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(906, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat86(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(906, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat88(int trans, int move, int color, int action)
{
  int c, d, A, B;
  UNUSED(color);
  UNUSED(action);

  c = AFFINE_TRANSFORM(644, trans, move);
  d = AFFINE_TRANSFORM(718, trans, move);
  A = AFFINE_TRANSFORM(572, trans, move);
  B = AFFINE_TRANSFORM(758, trans, move);

  return DRAGON_WEAK(A) || DRAGON_WEAK(B) || !(whose_moyo(OPPOSITE_INFLUENCE(color), c) == OTHER_COLOR(color)) || !(whose_moyo(OPPOSITE_INFLUENCE(color), d) == OTHER_COLOR(color));
}

static int
autohelperfusekipat100(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(942, trans, move);
  d = AFFINE_TRANSFORM(869, trans, move);
  e = AFFINE_TRANSFORM(906, trans, move);
  f = AFFINE_TRANSFORM(943, trans, move);
  g = AFFINE_TRANSFORM(794, trans, move);
  h = AFFINE_TRANSFORM(795, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f) && somewhere(color, 1, 2, g, h);
}

static int
autohelperfusekipat101(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(942, trans, move);
  d = AFFINE_TRANSFORM(869, trans, move);
  e = AFFINE_TRANSFORM(906, trans, move);
  f = AFFINE_TRANSFORM(943, trans, move);
  g = AFFINE_TRANSFORM(794, trans, move);
  h = AFFINE_TRANSFORM(795, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f) && somewhere(color, 1, 2, g, h);
}

static int
autohelperfusekipat102(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(868, trans, move);
  b = AFFINE_TRANSFORM(905, trans, move);
  c = AFFINE_TRANSFORM(942, trans, move);
  d = AFFINE_TRANSFORM(869, trans, move);
  e = AFFINE_TRANSFORM(906, trans, move);
  f = AFFINE_TRANSFORM(943, trans, move);
  g = AFFINE_TRANSFORM(609, trans, move);
  h = AFFINE_TRANSFORM(610, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f) && somewhere(OTHER_COLOR(color), 1, 2, g, h);
}

static int
autohelperfusekipat104(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(536, trans, move);
  b = AFFINE_TRANSFORM(537, trans, move);

  return somewhere(color, 1, 2, a, b);
}

static int
autohelperfusekipat114(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h, i, j, k, l, m, n, p, q, r, s;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(567, trans, move);
  b = AFFINE_TRANSFORM(604, trans, move);
  c = AFFINE_TRANSFORM(641, trans, move);
  d = AFFINE_TRANSFORM(568, trans, move);
  e = AFFINE_TRANSFORM(605, trans, move);
  f = AFFINE_TRANSFORM(642, trans, move);
  g = AFFINE_TRANSFORM(569, trans, move);
  h = AFFINE_TRANSFORM(606, trans, move);
  i = AFFINE_TRANSFORM(643, trans, move);
  j = AFFINE_TRANSFORM(833, trans, move);
  k = AFFINE_TRANSFORM(870, trans, move);
  l = AFFINE_TRANSFORM(907, trans, move);
  m = AFFINE_TRANSFORM(834, trans, move);
  n = AFFINE_TRANSFORM(871, trans, move);
  p = AFFINE_TRANSFORM(908, trans, move);
  q = AFFINE_TRANSFORM(835, trans, move);
  r = AFFINE_TRANSFORM(872, trans, move);
  s = AFFINE_TRANSFORM(909, trans, move);

  return somewhere(OTHER_COLOR(color), 1, 9, a, b, c, d, e, f, g, h, i) && somewhere(OTHER_COLOR(color), 1, 9, j, k, l, m, n, p, q, r, s);
}

static int
autohelperfusekipat131(int trans, int move, int color, int action)
{
  int a, b, c, d;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(832, trans, move);
  c = AFFINE_TRANSFORM(796, trans, move);
  d = AFFINE_TRANSFORM(833, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 4, a, b, c, d);
}

static int
autohelperfusekipat132(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(795, trans, move);
  b = AFFINE_TRANSFORM(832, trans, move);
  c = AFFINE_TRANSFORM(869, trans, move);
  d = AFFINE_TRANSFORM(796, trans, move);
  e = AFFINE_TRANSFORM(833, trans, move);
  f = AFFINE_TRANSFORM(870, trans, move);

  return  somewhere(OTHER_COLOR(color), 1, 6, a, b, c, d, e, f);
}

static int
autohelperfusekipat133(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(683, trans, move);

   add_antisuji_move(a);;

  return 0;
}

static int
autohelperfusekipat134(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(758, trans, move);

   add_antisuji_move(a);

  return 0;
}

static int
autohelperfusekipat137(int trans, int move, int color, int action)
{
  int a, b;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(722, trans, move);
  b = AFFINE_TRANSFORM(759, trans, move);

  return  somewhere(color, 1, 2, a, b);
}

static int
autohelperfusekipat141(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(723, trans, move);

   add_antisuji_move(a);

  return 0;
}

static int
autohelperfusekipat145(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(794, trans, move);

   add_replacement_move(a, move);

  return 0;
}

static int
autohelperfusekipat146(int trans, int move, int color, int action)
{
  int a;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(610, trans, move);

   add_replacement_move(a, move);

  return 0;
}

static int
autohelperfusekipat147(int trans, int move, int color, int action)
{
  int a, b, c, d, e, f, g, h;
  UNUSED(color);

  a = AFFINE_TRANSFORM(724, trans, move);
  b = AFFINE_TRANSFORM(761, trans, move);
  c = AFFINE_TRANSFORM(798, trans, move);
  d = AFFINE_TRANSFORM(835, trans, move);
  e = AFFINE_TRANSFORM(725, trans, move);
  f = AFFINE_TRANSFORM(762, trans, move);
  g = AFFINE_TRANSFORM(799, trans, move);
  h = AFFINE_TRANSFORM(836, trans, move);

  if (!action)
    return  somewhere(OTHER_COLOR(color), 1, 8, a, b, c, d, e, f, g, h);
   add_replacement_move(c, move); add_replacement_move(d, move);

  return 0;
}

static int
autohelperfusekipat148(int trans, int move, int color, int action)
{
  int a, b, c;
  UNUSED(color);
  UNUSED(action);

  a = AFFINE_TRANSFORM(757, trans, move);
  b = AFFINE_TRANSFORM(794, trans, move);
  c = AFFINE_TRANSFORM(611, trans, move);

  return  (!(whose_moyo(OPPOSITE_INFLUENCE(color), a) == color) || !(whose_moyo(OPPOSITE_INFLUENCE(color), b) == color)) && !ATTACK_MACRO(c);
}

static struct pattern fusekipat[] = {
  {fusekipat0,52,8, "F1",-1,-3,3,7,4,10,0xa,759,
    { 0x03ffffff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0x03ffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x80e000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat1,42,8, "F2",-1,-3,3,5,4,8,0xa,759,
    { 0x03ffffff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0x03ffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x803000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat2,47,8, "F3",-1,-3,3,6,4,9,0xa,759,
    { 0x03ffffff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0x03ffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10887000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat3,50,8, "F3h",-1,-3,3,6,4,9,0xa,759,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,0.025000,0.000000,0.000000,1,NULL,autohelperfusekipat3,3,0.010000},
  {fusekipat4,45,8, "F4",-1,-3,3,5,4,8,0xa,758,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x802000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat5,55,8, "F4a",-1,-3,3,7,4,10,0xa,758,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x806000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat6,50,8, "F5d",-1,-3,3,6,4,9,0xa,758,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x842000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat6,3,0.010000},
  {fusekipat7,45,8, "F5",-1,-3,3,5,4,8,0xa,795,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x802000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat8,55,8, "F5a",-1,-3,3,7,4,10,0xa,795,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x806000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat9,50,8, "F5h",-1,-3,3,6,4,9,0xa,795,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,0.010000,0.000000,0.000000,1,NULL,autohelperfusekipat9,3,0.010000},
  {fusekipat10,33,4, "F6",-2,-3,3,2,5,5,0xa,648,
    { 0xfcffffff, 0xfffffcf0, 0xffffff3f, 0xffffffff, 0xfcffffff, 0xfffffcf0, 0xffffff3f, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x810000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat11,22,4, "F7",-1,-3,3,1,4,4,0xa,648,
    { 0xc0f0fcfc, 0xfcf0c000, 0xff3f0f00, 0x0f3fffff, 0xc0f0fcfc, 0xfcf0c000, 0xff3f0f00, 0x0f3fffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10810000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat12,42,8, "F8",-2,-2,3,4,5,6,0xa,759,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x847000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat13,54,8, "F9",-2,-2,3,6,5,8,0xa,759,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat14,42,8, "F10",-2,-2,3,4,5,6,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x847000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat15,54,8, "F11",-2,-2,3,6,5,8,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat16,26,8, "F12",-3,-4,2,1,5,5,0xa,610,
    { 0xc0f0f0fc, 0xfff00000, 0x3f3f0f0f, 0x033fffff, 0x00f0ffff, 0xf0f0c0c0, 0xff3f0300, 0x0f3f3fff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10850000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat17,39,8, "F13",-4,-4,2,1,6,5,0xa,609,
    { 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0x03ffffff, 0x03ffffff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat18,57,8, "F14a",-7,-4,2,1,9,5,0xa,645,
    { 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff, 0x03ffffff, 0x03ffffff, 0xf0f0f0fc, 0xffff0300, 0x3f3f3fff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat19,36,8, "F14b",-1,-3,4,2,5,5,0xa,686,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat20,33,8, "F15",-2,-3,4,2,6,5,0xa,649,
    { 0xc0f0ffff, 0xfcf0c0c0, 0xff3f0f03, 0x0f3fffff, 0xc0f0fcff, 0xfff0c000, 0xff3f0f0f, 0x0f3fffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10850000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat21,36,4, "F16a",-3,-2,2,3,5,5,0xa,720,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10846000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat22,80,8, "F16b",-7,-2,2,5,9,7,0xa,718,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10846000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat23,80,8, "F17",-4,-3,3,6,7,9,0xa,759,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat24,80,8, "F18",-4,-3,3,6,7,9,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10847000,0.000000,0.000000,0.000000,0.000000,2.980000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat25,36,8, "F101",-2,-4,3,1,5,5,0xa,610,
    { 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat26,54,8, "F102",-2,-2,3,6,5,8,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,1,NULL,autohelperfusekipat26,0,0.010000},
  {fusekipat27,42,8, "F103",-2,-2,3,4,5,6,0xa,759,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat28,48,8, "F104",-2,-2,3,5,5,7,0xa,796,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10840000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat29,42,8, "F105",-3,-4,2,2,5,6,0xa,609,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat30,36,8, "F106",0,-3,5,2,5,5,0xa,724,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x10881000,0.000000,0.000000,0.000000,0.000000,-3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat31,36,8, "F107a",0,-2,5,3,5,5,0xa,761,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10881000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat32,42,8, "F107b",0,-2,6,3,6,5,0xa,725,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10881000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat33,36,8, "F108",0,-2,5,3,5,5,0xa,725,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x881000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat34,49,8, "F109",-3,-3,3,3,6,6,0xa,645,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,1,NULL,autohelperfusekipat34,0,0.010000},
  {fusekipat35,70,8, "F109b",-6,-3,3,3,9,6,0xa,645,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat36,60,8, "F110",-2,-3,3,6,5,9,0xa,759,
    { 0xffffffff, 0xfdfdffff, 0xffffffd7, 0xffffffff, 0xfffdfdff, 0xffffff5f, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat37,65,8, "F201",0,-3,4,9,4,12,0xa,908,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,0.500000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat38,65,8, "F202",0,-2,4,10,4,12,0xa,945,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10843000,0.000000,0.000000,0.000000,0.000000,0.500000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat39,40,8, "F203",0,-1,4,6,4,7,0x2,871,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x883000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat40,41,8, "F204",0,0,4,8,4,8,0x2,908,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x883000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat41,45,8, "F205",0,0,4,8,4,8,0x2,908,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10883000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat42,65,8, "F206",-1,-2,3,10,4,12,0xa,944,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00110000, 0x00100010, 0x00100000, 0x00100000, 0x00100000, 0x00110000, 0x00100010, 0x00100000}
   , 0x882000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat43,65,8, "F207",-1,-2,3,10,4,12,0xa,944,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00100100, 0x00100040, 0x00100000, 0x00100000, 0x00100000, 0x01100000, 0x00100004, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat44,45,8, "F208",0,-1,4,7,4,8,0x2,833,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x10883000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat45,114,8, "F209",-2,-3,3,15,5,18,0xe,906,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat46,84,8, "F210",-3,-3,3,8,6,11,0xa,906,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat47,40,8, "F301",-3,0,2,7,5,7,0x2,867,
    { 0x3f3f3f3f, 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x882000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat48,41,8, "F302",-3,0,2,6,5,6,0x2,867,
    { 0x3f3f3f3f, 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x882000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat49,42,8, "F303",-2,0,4,5,6,5,0x2,757,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100010, 0x00100000, 0x00100000, 0x00110000, 0x00100000, 0x00100000, 0x00110000, 0x00100010}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat50,42,8, "F304",-2,-5,4,0,6,5,0x2,537,
    { 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f},
    { 0x00200020, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220000, 0x00200020}
   , 0x882000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat51,25,8, "F305",0,0,4,4,4,4,0x2,758,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200004, 0x00200000, 0x00200000, 0x01200000, 0x00200000, 0x00200000, 0x00200100, 0x00200040}
   , 0x10800000,0.000000,0.000000,0.000000,0.000000,-5.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat52,48,8, "F306",-3,-5,2,2,5,7,0x2,682,
    { 0xfdfdffff, 0xffffffd7, 0xffffffff, 0xffffffff, 0xffffffff, 0xfffdfdff, 0xffffff5f, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x880000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat52,0,0.010000},
  {fusekipat53,39,8, "F307",-1,0,3,7,4,7,0x2,758,
    { 0x0f3f3f3f, 0x00f0fcfc, 0xf0f0c000, 0xff3f0000, 0xfcf00000, 0x3f3f0f00, 0x003fffff, 0xc0f0f0f0},
    { 0x00200900, 0x00208040, 0x80200000, 0x08200000, 0x80200000, 0x09200000, 0x00200804, 0x00208000}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat53,3,0.010000},
  {fusekipat54,32,8, "F401",-1,-5,2,3,3,8,0x2,573,
    { 0xfdfdfcfc, 0xfcfcfc14, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfdfd00, 0xffffff50, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x49000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat54,0,0.010000},
  {fusekipat55,29,8, "F402",-1,-1,2,6,3,7,0x2,795,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x89000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,jump_out_helper
,NULL,0,0.000000},
  {fusekipat56,35,8, "F403",-1,-6,3,1,4,7,0x2,537,
    { 0xe0f0f0fc, 0xfcf80000, 0x3f3f2f00, 0x03bfffff, 0x00f8fcfc, 0xf0f0e000, 0xffbf0300, 0x2f3f3fff},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x10849000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat57,35,8, "F404",-1,-6,3,1,4,7,0x2,536,
    { 0xe0f0f0fc, 0xfcf80000, 0x3f3f2f00, 0x03bfffff, 0x00f8fcfc, 0xf0f0e000, 0xffbf0300, 0x2f3f3fff},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x1084a000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat58,36,8, "F405",-1,-6,3,1,4,7,0x2,573,
    { 0xe0f0f0fc, 0xfcf80000, 0x3f3f2f00, 0x03bfffff, 0x00f8fcfc, 0xf0f0e000, 0xffbf0300, 0x2f3f3fff},
    { 0x00101000, 0x00500000, 0x10100000, 0x00140000, 0x00500000, 0x10100000, 0x00140000, 0x00101000}
   , 0x889000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat58,0,0.016000},
  {fusekipat59,31,8, "F407",-2,-1,2,6,4,7,0x2,795,
    { 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffff00, 0xffffffff, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x89000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat60,28,8, "F408",-1,-1,2,5,3,6,0x2,795,
    { 0xffbfffff, 0xecfcfcfc, 0xfcf8fc00, 0xffffef00, 0xfcfcec00, 0xffbfff00, 0xefffffff, 0xfcf8fcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x89000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat61,42,8, "F409",-2,-1,2,7,4,8,0x2,831,
    { 0xffffffff, 0xfcffffff, 0xfcfcfcf0, 0xffffff00, 0xfffffc00, 0xffffff3f, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat62,32,8, "F410",-1,-4,3,5,4,9,0x2,796,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x80a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat63,42,8, "F410a",-1,-4,3,5,4,9,0x2,796,
    { 0xffffffff, 0xfcfcfcfc, 0xfdfdfd00, 0xffffff55, 0xfcfcfc54, 0xffffff00, 0xffffffff, 0xfdfdfdfd},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1088a000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,1,NULL,autohelperfusekipat63,0,0.010000},
  {fusekipat64,50,8, "F410b",-1,-4,3,6,4,10,0x2,796,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1084a000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,1,NULL,autohelperfusekipat64,0,0.010000},
  {fusekipat65,83,8, "F410c",-3,-4,3,7,6,11,0x2,833,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x84a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat65,0,0.010000},
  {fusekipat66,45,8, "F410d",-1,0,3,8,4,8,0x2,796,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x889000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat66,0,0.010000},
  {fusekipat67,45,8, "F410e",-2,0,2,8,4,8,0x2,795,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x89000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat67,0,0.010000},
  {fusekipat68,31,4, "F411",-1,0,3,6,4,6,0x2,795,
    { 0x033f3f3f, 0x00f0f0fc, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0300, 0x003f3fff, 0x00f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1080a000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat69,33,8, "F412",0,-2,5,3,5,5,0x2,723,
    { 0x007cffff, 0xd0f0f0c0, 0xfff40000, 0x3f3f1f0f, 0xf0f0d0c0, 0xff7c0000, 0x1f3f3f0f, 0x00f4ffff},
    { 0x00200040, 0x00200000, 0x00200000, 0x00200100, 0x00200000, 0x00200000, 0x01200000, 0x00200004}
   , 0x1084e000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat70,45,8, "F413",-2,-4,2,4,4,8,0x2,795,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10800000,0.000000,0.000000,0.000000,0.000000,-5.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat71,80,8, "F420",-4,-3,3,6,7,9,0xa,645,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-2.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat72,80,8, "F421",-2,-2,5,7,7,9,0xa,724,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10883000,0.000000,0.000000,0.000000,0.000000,-3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat73,104,8, "F423",-2,-2,5,10,7,12,0xa,946,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-3.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat74,104,8, "F424",-2,-2,5,10,7,12,0xa,943,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100004, 0x00100000, 0x00100000, 0x01100000, 0x00100000, 0x00100000, 0x00100100, 0x00100040}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,-4.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat75,36,8, "F425",0,-2,3,6,3,8,0x2,833,
    { 0x007f7fff, 0x50f0f0f0, 0xf7f50000, 0x3f3f171d, 0xf0f050d0, 0x7f7f0000, 0x173f3f3f, 0x00f5f7fd},
    { 0x00201400, 0x00604000, 0x52200000, 0x04240008, 0x40600080, 0x14200000, 0x00240400, 0x00205200}
   , 0x840000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat76,36,8, "F426",0,-2,3,6,3,8,0x2,795,
    { 0x007f7fff, 0x50f0f0f0, 0xf7f50000, 0x3f3f171d, 0xf0f050d0, 0x7f7f0000, 0x173f3f3f, 0x00f5f7fd},
    { 0x00201400, 0x00604000, 0x52200000, 0x04240008, 0x40600080, 0x14200000, 0x00240400, 0x00205200}
   , 0x840000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat77,28,8, "F501",0,0,3,6,3,6,0x2,759,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x4d000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat78,28,8, "F502",-1,0,2,6,3,6,0x2,758,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x1008d000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat79,36,8, "F504",0,-7,3,1,3,8,0x2,537,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x40100000, 0x04100000, 0x00100400, 0x00104000}
   , 0x84d000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat79,0,0.010000},
  {fusekipat80,28,8, "F505",-1,-1,2,5,3,6,0x2,796,
    { 0xffffffff, 0xfcfcfcfc, 0xfcfcfc00, 0xffffff00, 0xfcfcfc00, 0xffffff00, 0xffffffff, 0xfcfcfcfc},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1088d000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat81,24,8, "F506",-1,0,2,5,3,5,0x2,795,
    { 0x3f3f2f3f, 0x00bcfcfc, 0xe0f0f000, 0xfffb0000, 0xfcbc0000, 0x2f3f3f00, 0x00fbffff, 0xf0f0e0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x1088d000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat82,35,8, "F601",-1,-4,3,2,4,6,0x2,573,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00212400, 0x00a04010, 0x60200000, 0x04280000, 0x40a00000, 0x24210000, 0x00280410, 0x00206000}
   , 0x846000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat83,36,8, "F602",-1,0,2,8,3,8,0x2,832,
    { 0x3f3f3f3f, 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff, 0xf0f0f0f0},
    { 0x00120000, 0x00100020, 0x00100000, 0x00100000, 0x00100000, 0x00120000, 0x00100020, 0x00100000}
   , 0x845000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat84,30,8, "F603",-2,0,3,4,5,4,0x2,758,
    { 0x3f3f3f3f, 0x00fdfdfd, 0xf0f0f050, 0xffff0000, 0xfdfd0000, 0x3f3f3f15, 0x00ffffff, 0xf0f0f0f0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x840000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat84,0,0.010000},
  {fusekipat85,48,8, "F701",0,0,3,11,3,11,0x2,870,
    { 0x003f1f3f, 0x0070f0f0, 0xd0f00000, 0x3f370000, 0xf0700000, 0x1f3f0000, 0x00373f3f, 0x00f0d0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10890010,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,1,NULL,autohelperfusekipat85,3,0.010000},
  {fusekipat86,48,8, "F702",-1,0,2,11,3,11,0x2,869,
    { 0x1f3f3f3f, 0x00f4fcfc, 0xf0f0d000, 0xff7f0000, 0xfcf40000, 0x3f3f1f00, 0x007fffff, 0xd0f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10890010,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,1,NULL,autohelperfusekipat86,3,0.010000},
  {fusekipat87,36,8, "F703",0,0,3,8,3,8,0x2,833,
    { 0x003f3f3f, 0x00f0f0f0, 0xf0f00000, 0x3f3f0000, 0xf0f00000, 0x3f3f0000, 0x003f3f3f, 0x00f0f0f0},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x890010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat88,33,8, "F704",-2,-1,3,5,5,6,0x2,796,
    { 0x3fffffff, 0xf0fcfcfc, 0xfcfcf000, 0xffff3f00, 0xfcfcf000, 0xffff3f00, 0x3fffffff, 0xf0fcfcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10890010,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,1,NULL,autohelperfusekipat88,3,0.021760},
  {fusekipat89,38,8, "F705",-1,-1,3,6,4,7,0x2,759,
    { 0x3fffffff, 0xf0fcfcfc, 0xfcfcf000, 0xffff3f00, 0xfcfcf000, 0xffff3f00, 0x3fffffff, 0xf0fcfcfc},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x890010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat90,28,8, "F706",0,0,3,6,3,6,0x2,833,
    { 0x003f2f2f, 0x00b0f0f0, 0xe0f00000, 0x3f3a0000, 0xf0b00000, 0x2f3f0000, 0x003a3f3f, 0x00f0e0e0},
    { 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000, 0x00100000}
   , 0x850010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat91,34,8, "F709",-2,0,3,5,5,5,0x2,757,
    { 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0xffff0000, 0x3f3f3f3f, 0x00ffffff, 0xf0f0f0f0},
    { 0x00200100, 0x00200040, 0x00200000, 0x00200000, 0x00200000, 0x01200000, 0x00200004, 0x00200000}
   , 0x822000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat92,70,8, "F801",0,-3,4,10,4,13,0xa,908,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200020, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220000, 0x00200020}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat93,70,8, "F802",0,-3,4,10,4,13,0xa,907,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200020, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220000, 0x00200020}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat94,70,8, "F803",0,-2,4,11,4,13,0xa,945,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat95,70,8, "F804",0,-2,4,11,4,13,0xa,944,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat96,70,8, "F805",-1,-2,3,11,4,13,0xa,944,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00220000, 0x00200020, 0x00200000, 0x00200000, 0x00200000, 0x00220000, 0x00200020, 0x00200000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat97,70,8, "F806",-1,-2,3,11,4,13,0xa,944,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200200, 0x00200080, 0x00200000, 0x00200000, 0x00200000, 0x02200000, 0x00200008, 0x00200000}
   , 0x10882000,0.000000,0.000000,0.000000,0.000000,3.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat98,114,8, "F807",-2,-3,3,15,5,18,0xe,906,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat99,114,8, "F808",-2,-3,3,15,5,18,0xe,907,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat100,70,8, "F809",0,-3,4,10,4,13,0xa,797,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200020, 0x00200000, 0x00200000, 0x00220000, 0x00200000, 0x00200000, 0x00220000, 0x00200020}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,1,NULL,autohelperfusekipat100,3,0.016000},
  {fusekipat101,75,8, "F810",0,-3,4,11,4,14,0xa,834,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,1,NULL,autohelperfusekipat101,3,0.016000},
  {fusekipat102,70,8, "F811",-1,-2,3,11,4,13,0xa,833,
    { 0xfffdfdff, 0xfcfcfc5c, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfdfdff00, 0xffffffd7, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x10842000,0.000000,0.000000,0.000000,0.000000,4.000000,0.000000,0.000000,1,NULL,autohelperfusekipat102,3,0.016000},
  {fusekipat103,42,8, "F901",-2,-6,3,0,5,6,0x2,610,
    { 0xd0f0f0f0, 0xfff50000, 0x3f3f1f1f, 0x007fffff, 0x00f5ffff, 0xf0f0d0d0, 0xff7f0000, 0x1f3f3f3f},
    { 0x00208000, 0x80200000, 0x09200000, 0x00200804, 0x00208040, 0x80200000, 0x08200000, 0x00200900}
   , 0x82a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat104,42,8, "F902",-2,-6,3,0,5,6,0x2,610,
    { 0xd0f0f0f0, 0xfff50000, 0x3f3f1f1f, 0x007fffff, 0x00f5ffff, 0xf0f0d0d0, 0xff7f0000, 0x1f3f3f3f},
    { 0x00208000, 0x80200000, 0x09200000, 0x00200804, 0x00208040, 0x80200000, 0x08200000, 0x00200900}
   , 0x82a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat104,3,0.010000},
  {fusekipat105,26,8, "J1",-1,-3,3,2,4,5,0xa,648,
    { 0xfcfdfcfc, 0xfcfcfc10, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfcfdfc00, 0xffffff10, 0xffffffff},
    { 0x00102000, 0x00900000, 0x20100000, 0x00180000, 0x00900000, 0x20100000, 0x00180000, 0x00102000}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat106,49,8, "J2",-1,-3,5,3,6,6,0xa,760,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200010, 0x00200000, 0x00200000, 0x00210000, 0x00200000, 0x00200000, 0x00210000, 0x00200010}
   , 0x82c010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat107,53,8, "J3",-1,-3,6,3,7,6,0xa,761,
    { 0xf0ffffff, 0xfcfcf0f0, 0xffff3f00, 0x3fffffff, 0xf0fcfcfc, 0xfffff000, 0xffff3f3f, 0x3fffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x82c010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat108,53,8, "J4",-1,-2,6,4,7,6,0xa,686,
    { 0xfcffffff, 0xfcfcfcf0, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xfffffc00, 0xffffff3f, 0xffffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x82c010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat109,33,8, "J5",0,-2,5,3,5,5,0xa,687,
    { 0x00f0ffff, 0xf0f0c0c0, 0xff3f0000, 0x0f3f3f3f, 0xc0f0f0f0, 0xfff00000, 0x3f3f0f0f, 0x003fffff},
    { 0x00200084, 0x00200000, 0x00200000, 0x01200200, 0x00200000, 0x00200000, 0x02200100, 0x00200048}
   , 0x82d010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat110,49,8, "J6",-1,-2,5,4,6,6,0xa,687,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00100008, 0x00100000, 0x00100000, 0x02100000, 0x00100000, 0x00100000, 0x00100200, 0x00100080}
   , 0x821010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat111,36,8, "J7",-2,-3,3,2,5,5,0xa,685,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00108000, 0x80100000, 0x08100000, 0x00100800, 0x00108000, 0x80100000, 0x08100000, 0x00100800}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat112,35,8, "J8",-2,-3,4,1,6,4,0xa,647,
    { 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff},
    { 0x00204008, 0x40200000, 0x04200000, 0x02200400, 0x00204000, 0x40200000, 0x04200200, 0x00200480}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat113,32,8, "J9",0,-1,3,6,3,7,0x2,870,
    { 0x00ffffff, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0x00fcfcfc},
    { 0x00208110, 0x80200040, 0x08200000, 0x00210800, 0x00208000, 0x81200000, 0x08210004, 0x00200810}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat114,112,8, "J10",-6,-2,4,8,10,10,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x842010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat114,3,0.016000},
  {fusekipat115,30,8, "J11",-2,-3,3,1,5,4,0xa,647,
    { 0xfcfcdcfc, 0xff7fff00, 0xdfffffff, 0xfff7ffff, 0xff7fffff, 0xdcfcfcfc, 0xfff7ff00, 0xffffdfff},
    { 0x00204000, 0x40200000, 0x04200000, 0x00200400, 0x00204000, 0x40200000, 0x04200000, 0x00200400}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat116,42,8, "J12",-2,-2,3,4,5,6,0xa,685,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00210000, 0x00200010, 0x00200000, 0x00200000, 0x00200000, 0x00210000, 0x00200010, 0x00200000}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat117,49,8, "J13",-1,-2,5,4,6,6,0xa,687,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00200084, 0x00200000, 0x00200000, 0x01200200, 0x00200000, 0x00200000, 0x02200100, 0x00200048}
   , 0x829010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat118,56,8, "J14",-4,-2,3,4,7,6,0xa,720,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x84e010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat119,56,8, "J15",-4,-2,3,4,7,6,0xa,719,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x84a010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat120,56,8, "J16",-4,-2,3,4,7,6,0xa,758,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x84a010,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat121,70,8, "J17",-3,-2,3,7,6,9,0xa,833,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00100200, 0x00100080, 0x00100000, 0x00100000, 0x00100000, 0x02100000, 0x00100008, 0x00100000}
   , 0x846000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat122,24,8, "J18",0,-3,3,2,3,5,0xa,648,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200110, 0x00200040, 0x00200000, 0x00210000, 0x00200000, 0x01200000, 0x00210004, 0x00200010}
   , 0x10849000,0.000000,0.000000,0.000000,0.000000,-1.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat123,45,8, "J19",-1,-3,3,5,4,8,0xa,721,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00220100, 0x00200060, 0x00200000, 0x00200000, 0x00200000, 0x01220000, 0x00200024, 0x00200000}
   , 0x1084c000,0.000000,0.000000,0.000000,0.000000,5.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat124,36,8, "J20",-1,-1,4,6,5,7,0xa,798,
    { 0xd4f4ffff, 0xfcf4d4c0, 0xfc7c5c00, 0x5f7fff00, 0xd4f4fc00, 0xfff4d400, 0xff7f5f0f, 0x5c7cfcfc},
    { 0x00201a15, 0x00608080, 0x90200000, 0x09250000, 0x80600000, 0x1a200000, 0x00250909, 0x00209050}
   , 0x829000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat125,34,8, "J21",0,-2,5,3,5,5,0xa,760,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x84a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat126,34,8, "J22",0,-2,5,3,5,5,0xa,760,
    { 0x007cffff, 0xd0f0f0c0, 0xfff70000, 0x3f3f1f3f, 0xf0f0d0f0, 0xff7c0000, 0x1f3f3f0f, 0x00f7ffff},
    { 0x00200008, 0x00200000, 0x00200000, 0x02200000, 0x00200000, 0x00200000, 0x00200200, 0x00200080}
   , 0x84a000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat127,24,8, "J23",0,-2,5,1,5,3,0xa,650,
    { 0x00fcfcfc, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f00, 0x00ffffff},
    { 0x00200084, 0x00200000, 0x00200000, 0x01200200, 0x00200000, 0x00200000, 0x02200100, 0x00200048}
   , 0x1080d000,0.000000,0.000000,0.000000,0.000000,2.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat128,40,8, "J24",0,-2,4,5,4,7,0xa,796,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00220004, 0x00200020, 0x00200000, 0x01200000, 0x00200000, 0x00220000, 0x00200120, 0x00200040}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat129,48,8, "J25",0,-2,5,5,5,7,0xa,797,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00110008, 0x00100010, 0x00100000, 0x02100000, 0x00100000, 0x00110000, 0x00100210, 0x00100080}
   , 0x1820000,30.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat130,48,8, "J26",0,-2,5,5,5,7,0xa,797,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00220004, 0x00200020, 0x00200000, 0x01200000, 0x00200000, 0x00220000, 0x00200120, 0x00200040}
   , 0x1820000,30.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat131,32,8, "J27",0,-2,5,4,5,6,0xa,686,
    { 0x00fcfcff, 0xf0f0f000, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfcfc0000, 0x3f3f3f03, 0x00ffffff},
    { 0x00200004, 0x00200000, 0x00200000, 0x01200000, 0x00200000, 0x00200000, 0x00200100, 0x00200040}
   , 0x900000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat131,3,0.010000},
  {fusekipat132,42,8, "J28",0,-2,5,5,5,7,0xa,686,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000, 0x00200000}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat132,3,0.010000},
  {fusekipat133,26,8, "J29",-1,-1,4,4,5,5,0xa,725,
    { 0xd4f4ffff, 0xfcf4d4c0, 0xfc7c5c00, 0x5f7fff00, 0xd4f4fc00, 0xfff4d400, 0xff7f5f0f, 0x5c7cfcfc},
    { 0x00201a16, 0x00608080, 0x90200000, 0x09250000, 0x80600000, 0x1a200000, 0x0025090a, 0x00209050}
   , 0x1800000,35.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,2,NULL,autohelperfusekipat133,3,0.000000},
  {fusekipat134,33,8, "J30",-1,-3,4,2,5,5,0x2,649,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00101820, 0x00508000, 0x91100000, 0x08160004, 0x80500040, 0x18100000, 0x00160800, 0x00109120}
   , 0x82c000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,2,NULL,autohelperfusekipat134,0,0.000000},
  {fusekipat135,54,8, "J31",0,-3,5,5,5,8,0xa,685,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200111, 0x00200040, 0x00200000, 0x00210000, 0x00200000, 0x01200000, 0x00210005, 0x00200010}
   , 0x900000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat136,54,8, "J32",0,-2,5,6,5,8,0xa,650,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200084, 0x00200000, 0x00200000, 0x01200200, 0x00200000, 0x00200000, 0x02200100, 0x00200048}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat137,42,8, "J33",0,-2,5,4,5,6,0xa,760,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200824, 0x00208000, 0x80200000, 0x09220000, 0x80200000, 0x08200000, 0x00220900, 0x00208060}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat137,3,0.010000},
  {fusekipat138,42,8, "J34",0,-2,5,4,5,6,0xa,649,
    { 0x00ffffff, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xffff0000, 0x3f3f3f3f, 0x00ffffff},
    { 0x00200824, 0x00208000, 0x80200000, 0x09220000, 0x80200000, 0x08200000, 0x00220900, 0x00208060}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat139,42,8, "J35",0,-2,5,4,5,6,0xa,724,
    { 0x00ff5fff, 0x7070f0f0, 0xd7ff0000, 0x3f37373f, 0xf07070f0, 0x5fff0000, 0x37373f3f, 0x00ffd7ff},
    { 0x00200864, 0x00208000, 0x80200000, 0x09220100, 0x80200000, 0x08200000, 0x01220900, 0x00208064}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat140,27,8, "J36",-2,-3,3,1,5,4,0xa,649,
    { 0xe0f0fcfc, 0xfefac000, 0xff3f2f2b, 0x0fbfffff, 0xc0fafeff, 0xfcf0e0a0, 0xffbf0f00, 0x2f3fffff},
    { 0x00106800, 0x40908000, 0xa4100000, 0x08180400, 0x80904000, 0x68100000, 0x04180800, 0x0010a400}
   , 0x84c000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat141,26,8, "J37",-1,-3,3,2,4,5,0xa,722,
    { 0xa0f0ffff, 0xf8f8c0c0, 0xff3f2b00, 0x0fbfbfff, 0xc0f8f8fc, 0xfff0a000, 0xbfbf0f0f, 0x2b3fffff},
    { 0x00100206, 0x00100080, 0x00100000, 0x01100000, 0x00100000, 0x02100000, 0x0010010a, 0x00100040}
   , 0x880000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,2,NULL,autohelperfusekipat141,0,0.000000},
  {fusekipat142,30,8, "J38",-2,-2,2,3,4,5,0x8,757,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00161928, 0x00509060, 0x90500000, 0x1a160000, 0x90500000, 0x19160000, 0x00161a24, 0x005090a0}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat143,35,8, "J39",-1,-4,3,2,4,6,0x8,721,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00106890, 0x40908000, 0xa5100000, 0x08190605, 0x80904040, 0x68100000, 0x06190800, 0x0010a519}
   , 0x840000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat144,54,8, "J40",0,-2,5,6,5,8,0xa,798,
    { 0x00f7efef, 0xf0b0d0f0, 0xef7f0000, 0x1f3a3f3f, 0xd0b0f0f0, 0xeff70000, 0x3f3a1f3f, 0x007fefef},
    { 0x00200004, 0x00200000, 0x00200000, 0x01200000, 0x00200000, 0x00200000, 0x00200100, 0x00200040}
   , 0x820000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat145,36,8, "J41",-2,-3,3,2,5,5,0xa,647,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00206100, 0x40a00040, 0x24200000, 0x00280400, 0x00a04000, 0x61200000, 0x04280004, 0x00202400}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,2,NULL,autohelperfusekipat145,3,0.000000},
  {fusekipat146,61,8, "J42",0,-3,8,3,8,6,0x8,690,
    { 0x00fcffff, 0xf0f0f0c0, 0xffff0000, 0x3f3f3f3f, 0xf0f0f0f0, 0xfffc0000, 0x3f3f3f0f, 0x00ffffff},
    { 0x00280540, 0x00206040, 0x40a00000, 0x24200100, 0x60200000, 0x05280000, 0x01202404, 0x00a04004}
   , 0x40000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,2,NULL,autohelperfusekipat146,3,0.000000},
  {fusekipat147,45,8, "J43",-2,-3,4,3,6,6,0x9,647,
    { 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff},
    { 0x00280540, 0x00206040, 0x40a00000, 0x24200100, 0x60200000, 0x05280000, 0x01202404, 0x00a04004}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,3,NULL,autohelperfusekipat147,3,0.010000},
  {fusekipat148,23,8, "J44",0,-1,3,6,3,7,0x2,759,
    { 0x003fff7f, 0xc0f0f0f0, 0xfcf00000, 0x3f3f0d00, 0xf0f0c000, 0xff3f0000, 0x0d3f3f3f, 0x00f0fcf4},
    { 0x00109024, 0x80500000, 0x18100000, 0x01160800, 0x00508000, 0x90100000, 0x08160100, 0x00101860}
   , 0x40000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,1,NULL,autohelperfusekipat148,0,0.376000},
  {fusekipat149,55,8, "J45",-2,-2,3,8,5,10,0x2,870,
    { 0x2fbfffff, 0xe0f8ffff, 0xfef8e0c0, 0xffbf2f0b, 0xfff8e080, 0xffbf2f0f, 0x2fbfffff, 0xe0f8feff},
    { 0x00104000, 0x40100000, 0x04100000, 0x00100400, 0x00104000, 0x40100000, 0x04100000, 0x00100400}
   , 0x40000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat150,44,8, "J46",-3,-2,4,3,7,5,0x5,649,
    { 0xffffffff, 0xffffffff, 0xfffcfcfc, 0xffffff0f, 0xffffffc0, 0xffffffff, 0xffffffff, 0xfcfcffff},
    { 0x00200824, 0x00208000, 0x80200000, 0x09220000, 0x80200000, 0x08200000, 0x00220900, 0x00208060}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,3,0.000000},
  {fusekipat151,36,8, "J47",-2,-2,3,4,5,6,0x9,720,
    { 0xffffffe7, 0xffffffff, 0xffffffff, 0xfdfeffff, 0xffffffff, 0xffffffff, 0xfffefdff, 0xffffff6f},
    { 0x00181800, 0x0050a000, 0x90900000, 0x28140000, 0xa0500000, 0x18180000, 0x00142800, 0x00909000}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat152,36,8, "J47b",-1,-3,4,3,5,6,0x9,647,
    { 0xfffffffc, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xfffffffc, 0xffffffff},
    { 0x00186160, 0x40902040, 0x24900000, 0x201a0500, 0x20904000, 0x61180000, 0x051a2004, 0x00902424}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {fusekipat153,40,8, "J48",-1,-2,3,5,4,7,0x9,758,
    { 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xfcfcfcfc, 0xffffff00, 0xffffffff, 0xffffffff},
    { 0x00102420, 0x00904000, 0x60100000, 0x041a0000, 0x40900000, 0x24100000, 0x001a0400, 0x00106020}
   , 0x20000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0.000000,0,NULL,NULL,0,0.000000},
  {NULL, 0,0,NULL,0,0,0,0,0,0,0,0,{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0,NULL,NULL,0,0.0}
};

struct pattern_db fusekipat_db = {
  -1,
  0,
  fusekipat
 , NULL
};
